/*----- PROTECTED REGION ID(DynAttrTest.java) ENABLED START -----*/
//=============================================================================
//
// file :        DynAttrTest.java
//
// description : Java source for the DynAttrTest class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               DynAttrTest are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/    //	DynAttrTest.java

package org.tango.dynattrtest;

/*----- PROTECTED REGION ID(DynAttrTest.imports) ENABLED START -----*/

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.ext.XLogger;
import org.slf4j.ext.XLoggerFactory;
import org.tango.DeviceState;
import org.tango.server.InvocationContext;
import org.tango.server.ServerManager;
import org.tango.server.annotation.AroundInvoke;
import org.tango.server.annotation.Attribute;
import org.tango.server.annotation.AttributeProperties;
import org.tango.server.annotation.ClassProperty;
import org.tango.server.annotation.Command;
import org.tango.server.annotation.Delete;
import org.tango.server.annotation.Device;
import org.tango.server.annotation.DeviceProperty;
import org.tango.server.annotation.DynamicManagement;
import org.tango.server.annotation.Init;
import org.tango.server.annotation.State;
import org.tango.server.annotation.StateMachine;
import org.tango.server.annotation.Status;
import org.tango.server.annotation.DeviceManagement;
import org.tango.server.annotation.Pipe;
import org.tango.server.attribute.ForwardedAttribute;
import org.tango.server.attribute.IAttributeBehavior;
import org.tango.server.pipe.PipeValue;
import org.tango.server.dynamic.DynamicManager;
import org.tango.server.device.DeviceManager;
import org.tango.server.dynamic.DynamicManager;
import org.tango.server.events.EventManager;
import org.tango.server.events.EventType;
import org.tango.utils.DevFailedUtils;

//	Import Tango IDL types
import fr.esrf.Tango.*;
import fr.esrf.TangoDs.Except;
import fr.esrf.TangoApi.PipeBlob;
import fr.esrf.TangoApi.PipeDataElement;

/*----- PROTECTED REGION END -----*/    //	DynAttrTest.imports

/**
 * DynAttrTest class description:
 */

@Device
public class DynAttrTest {

    protected static final Logger logger = LoggerFactory.getLogger(DynAttrTest.class);
    protected static final XLogger xlogger = XLoggerFactory.getXLogger(DynAttrTest.class);
    //========================================================
    //	Programmer's data members
    //========================================================
    /*----- PROTECTED REGION ID(DynAttrTest.variables) ENABLED START -----*/

    //	Put static variables here
    
    /*----- PROTECTED REGION END -----*/    //	DynAttrTest.variables
    /*----- PROTECTED REGION ID(DynAttrTest.private) ENABLED START -----*/

    //	Put private variables here
	
	/*----- PROTECTED REGION END -----*/    //	DynAttrTest.private

    //========================================================
    //	Property data members and related methods
    //========================================================


    //========================================================
    //	Miscellaneous methods
    //========================================================

    /**
     * Initialize the device.
     *
     * @throws DevFailed if something fails during the device initialization.
     */
    @Init(lazyLoading = false)
    public void initDevice() throws DevFailed {
        xlogger.entry();
        logger.debug("init device " + deviceManager.getName());
		/*----- PROTECTED REGION ID(DynAttrTest.initDevice) ENABLED START -----*/

        //	Put your device initialization code here
        CreateDynAttr();
        setState(DevState.ON);
        setStatus("Device is operational");
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.initDevice
        xlogger.exit();
    }

    /**
     * all resources may be closed here. Collections may be also cleared.
     *
     * @throws DevFailed if something fails during the device object deletion.
     */
    @Delete
    public void deleteDevice() throws DevFailed {
        xlogger.entry();
		/*----- PROTECTED REGION ID(DynAttrTest.deleteDevice) ENABLED START -----*/

        //	Put your device clearing code here
        System.out.println("Inside Delete Device");
        for (int i = 1; i < 5; i++) {
            String attrName = "Str" + i;
            deviceManager.stopPolling(attrName);
        }

        dynamicManager.clearAttributes();
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.deleteDevice
        xlogger.exit();
    }

    /**
     * Method called before and after command and attribute calls.
     *
     * @param ctx the invocation context
     * @throws DevFailed if something fails during this method execution.
     */
    @AroundInvoke
    public void aroundInvoke(final InvocationContext ctx) throws DevFailed {
        xlogger.entry();
			/*----- PROTECTED REGION ID(DynAttrTest.aroundInvoke) ENABLED START -----*/

        //	Put aroundInvoke code here
			
			/*----- PROTECTED REGION END -----*/    //	DynAttrTest.aroundInvoke
        xlogger.exit();
    }


    /**
     * dynamic command and attribute management. Will be injected by the framework.
     */
    @DynamicManagement
    protected DynamicManager dynamicManager;

    /**
     * @param dynamicManager the DynamicManager instance
     * @throws DevFailed if something fails during this method execution.
     */
    public void setDynamicManager(final DynamicManager dynamicManager) throws DevFailed {
        this.dynamicManager = dynamicManager;
		/*----- PROTECTED REGION ID(DynAttrTest.setDynamicManager) ENABLED START -----*/

        //	Put your code here
		
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.setDynamicManager
    }

    /**
     * Device management. Will be injected by the framework.
     */
    @DeviceManagement
    DeviceManager deviceManager;

    public void setDeviceManager(DeviceManager deviceManager) {
        this.deviceManager = deviceManager;
    }


    //========================================================
    //	Command data members and related methods
    //========================================================
    /**
     * The state of the device
     */
    @State
    private DevState state = DevState.UNKNOWN;

    /**
     * Execute command "State".
     * description: This command gets the device state (stored in its 'state' data member) and returns it to the caller.
     *
     * @return Device state
     * @throws DevFailed if command execution failed.
     */
    public final DevState getState() throws DevFailed {
		/*----- PROTECTED REGION ID(DynAttrTest.getState) ENABLED START -----*/

        //	Put state code here
		
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.getState
        return state;
    }

    /**
     * Set the device state
     *
     * @param state the new device state
     */
    public void setState(final DevState state) {
        this.state = state;
    }

    /**
     * The status of the device
     */
    @Status
    private String status = "Server is starting. The device state is unknown";

    /**
     * Execute command "Status".
     * description: This command gets the device status (stored in its 'status' data member) and returns it to the caller.
     *
     * @return Device status
     * @throws DevFailed if command execution failed.
     */
    public final String getStatus() throws DevFailed {
		/*----- PROTECTED REGION ID(DynAttrTest.getStatus) ENABLED START -----*/

        //	Put status code here
		
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.getStatus
        return status;
    }

    /**
     * Set the device status
     *
     * @param status the new device status
     */
    public void setStatus(final String status) {
        this.status = status;
    }

    /**
     * Execute command "CreateDynAttr".
     * description:
     *
     * @throws DevFailed if command execution failed.
     */
    @Command(name = "CreateDynAttr", inTypeDesc = "", outTypeDesc = "")
    public void CreateDynAttr() throws DevFailed {
        xlogger.entry();
		/*----- PROTECTED REGION ID(DynAttrTest.createDynAttr) ENABLED START -----*/

        //	Put command code here
        if(dynamicManager.getDynamicAttributes().size() == 0) {
            for (int i = 1; i < 5; i++) {
                String attrName = "Str" + i;
                dynamicManager.addAttribute(new StrAttr(attrName));
                deviceManager.startPolling(attrName, 1000);
            }
        }

		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.createDynAttr
        xlogger.exit();
    }

    /**
     * Execute command "DeleteDynAttr".
     * description:
     *
     * @throws DevFailed if command execution failed.
     */
    @Command(name = "DeleteDynAttr", inTypeDesc = "", outTypeDesc = "")
    public void DeleteDynAttr() throws DevFailed {
        xlogger.entry();
		/*----- PROTECTED REGION ID(DynAttrTest.deleteDynAttr) ENABLED START -----*/

        //	Put command code here
        for (int i = 1; i < 5; i++) {
            String attrName = "Str" + i;
            deviceManager.stopPolling(attrName);
        }
        dynamicManager.clearAttributes();
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.deleteDynAttr
        xlogger.exit();
    }


    //========================================================
    //	Programmer's methods
    //========================================================
	/*----- PROTECTED REGION ID(DynAttrTest.methods) ENABLED START -----*/

    //	Put your own methods here
	
	/*----- PROTECTED REGION END -----*/    //	DynAttrTest.methods


    /**
     * Starts the server.
     *
     * @param args program arguments (instance_name [-v[trace level]]  [-nodb [-dlist <device name list>] [-file=fileName]])
     */
    public static void main(final String[] args) {
		/*----- PROTECTED REGION ID(DynAttrTest.main) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/    //	DynAttrTest.main
        ServerManager.getInstance().start(args, DynAttrTest.class);
        System.out.println("------- Started -------------");
    }
}
