/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.java) ENABLED START -----*/
//=============================================================================
//
// file :        StrAttr.java
//
// description : Java source for the dynamic attribute StrAttr.
//               this attribute belongs to the DynAttrTest class.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.java

package org.tango.dynattrtest;

import org.tango.DeviceState;
import org.tango.server.StateMachineBehavior;
import org.tango.server.attribute.IAttributeBehavior;
import org.tango.server.attribute.AttributeValue;
import org.tango.server.attribute.AttributeConfiguration;
import org.tango.server.attribute.AttributePropertiesImpl;

//	Import Tango IDL types
import fr.esrf.Tango.*;


/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.addImports) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.addImports


/**
 * Dynamic attribute StrAttr, String, Scalar, READ_WRITE
 * description:
 *     
 */
public class StrAttr implements IAttributeBehavior {

	/**	The attribute name */
	private String  attributeName;

	/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.dataMembers) ENABLED START -----*/
	
	//	Put your data member declarations
    private String readValue = Long.toHexString(Double.doubleToLongBits(Math.random()));
    private String writeValue = "";
	/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.dataMembers

	/**
	 * Dynamic attribute StrAttr constructor
	 * @param attributeName The dynamic attribute name
	 */
	public StrAttr(String attributeName) {
		this.attributeName = attributeName;
	}

	/**
	 * Build and return the configuration for dynamic attribute StrAttr.
	 * @return the configuration for dynamic attribute StrAttr.
	 * @throws DevFailed in case of configuration error.
	 */
	@Override
	public AttributeConfiguration getConfiguration() throws DevFailed {
		AttributeConfiguration  config = new AttributeConfiguration();
		config.setName(attributeName);
		config.setType(String.class);
		config.setFormat(AttrDataFormat.SCALAR);
		config.setWritable(AttrWriteType.READ_WRITE);
		config.setDispLevel(DispLevel.OPERATOR);
		config.setPolled(true);
		config.setPollingPeriod(3000);
		config.setMemorized(true);
		config.setMemorizedAtInit(true);
	
		//	Set attribute properties
		AttributePropertiesImpl	properties = new AttributePropertiesImpl();
		properties.setEventPeriod("3000");
		config.setAttributeProperties(properties);
		return config;
	}

	/**
	 * Get dynamic attribute state machine
	 * @return the attribute state machine
	 * @throws DevFailed if the state machine computation failed.
	 */
	@Override
	public StateMachineBehavior getStateMachine() throws DevFailed {
		StateMachineBehavior stateMachine = new StateMachineBehavior();
		/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.getStateMachine) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.getStateMachine
		return stateMachine;
	}

	/**
	 * Get dynamic attribute value
	 * @return the attribute value
	 * @throws DevFailed if the read value failed.
	 */
	@Override
	public AttributeValue getValue() throws DevFailed {
		String	readValue;
		/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.getValue) ENABLED START -----*/
        readValue = this.readValue;
		/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.getValue
		return new AttributeValue(readValue);
	}

	/**
	 * Set dynamic attribute value
	 * @param writeValue the attribute value
	 * @throws DevFailed if the set value failed.
	 */
	@Override
	public void setValue(AttributeValue writeValue) throws DevFailed {
		/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.setValue) ENABLED START -----*/
		System.out.println("Writing " + writeValue + "to hardware");
        this.writeValue = (String) writeValue.getValue();
        this.readValue = this.writeValue;
		/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.setValue
	}

	/*----- PROTECTED REGION ID(DynAttrTest.StrAttr.methods) ENABLED START -----*/
	
	//	Put your own methods
	
	/*----- PROTECTED REGION END -----*/	//	DynAttrTest.StrAttr.methods
}
